summaryrefslogtreecommitdiff
path: root/servant-client-core.cabal
blob: 3d1055db29401887f7457cb93ce984d5f76f230b (plain)
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
cabal-version:       >=1.10
name:                servant-client-core
version:             0.17

synopsis:            Core functionality and class for client function generation for servant APIs
category:            Servant, Web
description:
  This library provides backend-agnostic generation of client functions. For
  more information, see the README.

homepage:            http://docs.servant.dev/
bug-reports:         http://github.com/haskell-servant/servant/issues
license:             BSD3
license-file:        LICENSE
author:              Servant Contributors
maintainer:          haskell-servant-maintainers@googlegroups.com
copyright:           2014-2016 Zalora South East Asia Pte Ltd, 2016-2019 Servant Contributors
build-type:          Simple
tested-with:
  GHC ==8.0.2
   || ==8.2.2
   || ==8.4.4
   || ==8.6.5
   || ==8.8.2
  , GHCJS == 8.4

extra-source-files:
  CHANGELOG.md
  README.md

source-repository head
  type:              git
  location:          http://github.com/haskell-servant/servant.git

library
  exposed-modules:
      Servant.Client.Core
      Servant.Client.Free
      Servant.Client.Generic
      Servant.Client.Core.Reexport
      Servant.Client.Core.Auth
      Servant.Client.Core.BaseUrl
      Servant.Client.Core.BasicAuth
      Servant.Client.Core.ClientError
      Servant.Client.Core.HasClient
      Servant.Client.Core.Request
      Servant.Client.Core.Response
      Servant.Client.Core.RunClient

  other-modules:
      Servant.Client.Core.Internal

  -- Bundled with GHC: Lower bound to not force re-installs
  -- text and mtl are bundled starting with GHC-8.4
  --
  -- note: mtl lower bound is so low because of GHC-7.8
  build-depends:
      base                  >= 4.9      && < 4.14
    , bytestring            >= 0.10.8.1 && < 0.11
    , containers            >= 0.5.7.1  && < 0.7
    , deepseq               >= 1.4.2.0  && < 1.5
    , text                  >= 1.2.3.0  && < 1.3
    , transformers          >= 0.5.2.0  && < 0.6
    , template-haskell      >= 2.11.1.0 && < 2.16

  if !impl(ghc >= 8.2)
    build-depends:
      bifunctors >= 5.5.3 && < 5.6

  -- Servant dependencies
  build-depends:
      servant            >= 0.17 && <0.18

  -- Other dependencies: Lower bound around what is in the latest Stackage LTS.
  -- Here can be exceptions if we really need features from the newer versions.
  build-depends:
      aeson                 >= 1.4.1.0  && < 1.5
    , base-compat           >= 0.10.5   && < 0.12
    , base64-bytestring     >= 1.0.0.1  && < 1.1
    , exceptions            >= 0.10.0   && < 0.11
    , free                  >= 5.1      && < 5.2
    , http-media            >= 0.7.1.3  && < 0.9
    , http-types            >= 0.12.2   && < 0.13
    , network-uri           >= 2.6.1.0  && < 2.7
    , safe                  >= 0.3.17   && < 0.4

  hs-source-dirs:      src
  default-language:    Haskell2010
  ghc-options:         -Wall

test-suite spec
  type:                exitcode-stdio-1.0
  ghc-options:         -Wall
  default-language:    Haskell2010
  hs-source-dirs:      test
  main-is:             Spec.hs
  other-modules:
      Servant.Client.Core.Internal.BaseUrlSpec
      Servant.Client.Core.RequestSpec

  -- Dependencies inherited from the library. No need to specify bounds.
  build-depends:
      base
    , base-compat
    , servant-client-core

  -- Additonal dependencies
  build-depends:
      deepseq    >= 1.4.2.0  && < 1.5
    , hspec      >= 2.6.0    && < 2.8
    , QuickCheck >= 2.12.6.1 && < 2.14

  build-tool-depends:
    hspec-discover:hspec-discover >= 2.6.0 && <2.8